package com.tencent.captchademo;

import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.tencent.captchasdk.TCaptchaDialog;
import com.tencent.captchasdk.TCaptchaPopupActivity;
import com.tencent.captchasdk.TCaptchaVerifyListener;

import org.json.JSONObject;

import java.net.URLEncoder;

public class MainActivity extends AppCompatActivity implements View.OnClickListener{
    private TCaptchaDialog dialog;
    private Dialog.OnCancelListener cancelListener = new Dialog.OnCancelListener(){
        @Override
        public void onCancel(DialogInterface dialog) {
            Toast.makeText(MainActivity.this, "用戶可能按了返回键，关闭验证码未验证成功", Toast.LENGTH_SHORT).show();

        }
    };
    private TCaptchaVerifyListener captchaVerifyListener = new TCaptchaVerifyListener() {
        @Override
        public void onVerifyCallback(JSONObject jsonObject) {
            handleCallback(jsonObject);
        }

    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        findViewById(R.id.verifybt_popup).setOnClickListener(this);
        findViewById(R.id.verifybt_dialog_popup).setOnClickListener(this);

    }
    @Override
    public void onClick(final View view) {
        EditText input = findViewById(R.id.uin);
        String uin = input.getText().toString();
        switch(view.getId()){
            case R.id.verifybt_popup:
                try {
                    Intent intent = new Intent(this, TCaptchaPopupActivity.class);
                    intent.putExtra("appid","1234");
                    if (uin != null && uin.length() >0) {
                        JSONObject jsonObject = new JSONObject();
                        jsonObject.put("uin", Integer.parseInt(uin));
                        intent.putExtra("map", URLEncoder.encode(jsonObject.toString(),"utf-8"));
                    }
                    startActivityForResult(intent,1);
                }catch(Exception e){
                    e.printStackTrace();
                }
                break;
            case R.id.verifybt_dialog_popup:
                try{
                if (dialog != null){
                    dialog.dismiss();
                }
                String map = null;
                if (uin != null && uin.length() >0) {
                    JSONObject jsonObject = new JSONObject();
                    jsonObject.put("uin", Integer.parseInt(uin));
                    jsonObject.put("但是法律框架","sdfklj sfd史蒂夫");
                    map = URLEncoder.encode(jsonObject.toString(),"utf-8");
                }
                dialog = new TCaptchaDialog(MainActivity.this, true,cancelListener,"1234",captchaVerifyListener,map);
                dialog.show();
                }catch(Exception e){
                    e.printStackTrace();
                }
                break;
            default:
                break;
        }

    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 1) {
            switch(resultCode){
                case Activity.RESULT_OK: {
                    if (data != null) {
                        try {
                            String retJson = data.getStringExtra("retJson");
                            JSONObject jsonObject = new JSONObject(retJson);
                            handleCallback(jsonObject);
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }
                    break;
                }
                case Activity.RESULT_CANCELED: {

                    Toast.makeText(MainActivity.this, "用戶可能按了返回键，关闭验证码未验证成功", Toast.LENGTH_SHORT).show();
                    break;
                }
                default:break;
            }
        }
    }
    private void  handleCallback(JSONObject jsonObject){
        try {
            int ret = jsonObject.getInt("ret");
            String info;
            if (ret == 0) { //验证成功
                info = String.format("验证成功:%s", jsonObject.toString());
            } else if (ret == -1001) {// 首个TCaptcha.js加载错误时允许用户(操作者)或业务方(接入方)介入重试
                info = String.format("验证码加载错误:%s", jsonObject.toString());
            } else { //用户(可能)点了验证码的关闭按钮
                info = String.format("用戶(可能)关闭验证码未验证成功:%s", jsonObject.toString());
            }
            Toast.makeText(MainActivity.this, info, Toast.LENGTH_SHORT).show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public void onDestroy(){
        if (dialog != null) {
            dialog.dismiss();
            dialog = null;
        }
        super.onDestroy();
    }
}
